#include <bits/stdc++.h>

#define ll long long
using namespace std;
ll n, k, t;
vector<vector<ll>> G;

ll binp(ll a,ll b){
    ll l=0;
    ll r=n+1;
    ll m;
    while(l+1!=r){
        m=(l+r)/2;
        if(m==0){
            return -1;
        }
        if(a/m + b/m - (a%m==0 and a!=0) - (b%m==0 and b!=0) <=k){
            r=m;
        }
        else{
            l=m;
        }
    }
    return l + 1;
}

void solve1() {
    if(t==0){
        cout<<binp(0,n-1);
    }
    else{
        for(ll i=0;i<n;i++){
            cout<<binp(i,n-i - 1)<<" ";
        }
    }
}

vector<ll> color;
vector<bool> used;
queue<ll> Q;
vector<ll> List;

void bfs(ll a) {
    for (ll to: G[a]) {
        if (!used[to]) {
            color[to] = color[a] + 1;
            used[to] = true;
            Q.push(to);
        }
    }
    if (Q.empty()) {
        return;
    }
    ll b = Q.front();
    Q.pop();
    bfs(b);
}

void dfs(ll a) {
    used[a] = true;
    for (auto to: G[a]) {
        if (!used[to]) {
            dfs(to);
            List[a] = max(List[a], List[to]);
        }
    }
}

vector<ll> LVL;

void getAns(ll a) {
    color.resize(n, 0);
    used.resize(n, false);
    List.resize(n);
    used[a] = true;
    Q.push(a);
    bfs(a);
    LVL.resize(n, 0);
    for (ll i = 0; i < n; i++) {
        LVL[color[i]]++;
    }
    for (ll i = 0; i < n; i++) {
        List[i] = color[i];
    }
    used.assign(n , false);
    dfs(0);
    set<ll> A;
    ll mx = 0;
    ll mx1;
    for (auto i:G[0]) {
        if (List[i] >= mx) {
            mx1 = mx;
            mx = List[i];
        } else if (List[i] > mx1) {
            mx1 = List[i];
        }
    }
    if (mx1 == mx) {
        cout << mx;
        return;
    }
    ll ans = 1e18;
    for (ll i = 1; i < n; i++) {
        if (List[i] == mx) {
            ans = min(ans, max(max(mx1, color[i] - 1), mx - color[i] + 1));
        }
    }
    cout<<ans;
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    cin >> n >> k >> t;
    ll a, b;
    G.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        cin >> a >> b;
        a--, b--;
        G[a].push_back(b);
        G[b].push_back(a);
    }
    if (k == 1 and t == 0) {
        getAns(0);
        return 0;
    }
    else{
        solve1();
    }
}