#include <bits/stdc++.h>

#define ll long long
using namespace std;
vector<pair<ll, ll>> G;
ll n;
ll q;
vector<ll> T;
ll p;
vector<ll> D;
vector<ll> Ans;

void build(ll v, ll l, ll r) {
    if (l + 1 == r) {
        D[v] = -1;
        return;
    }
    build(2 * v, l, (l + r) / 2);
    build(2 * v + 1, (l + r) / 2, r);
}

void change(ll v, ll l, ll r, ll tl, ll tr, ll x) {
    if (l + 1 != r) {
        D[2 * v] = D[v];
        D[2 * v + 1] = D[v];
    }
    if (tl == l and tr == r) {
        D[v] = x;
        return;
    }
    ll m = (l + r) / 2;
    if (m <= tl) {
        change(2 * v + 1, m, r, tl, tr, x);
        return;
    }
    if (m >= tr) {
        change(2 * v, l, m, tl, tr, x);
        return;
    }
    change(2 * v + 1, m, r, tl, tr, x);
    change(2 * v, l, m, tl, tr, x);
}

ll get(ll v, ll l, ll r, ll tl) {
    if (l + 1 == r) {
        return D[v];
    }
    ll m = (l + r) / 2;
    if (tl >= m) {
        return get(2 * v + 1, m, r, tl);
    }
    return get(2 * v, l, m, tl);
}

void path(ll a) {
    if (a == -1) {
        return;
    }
    if (T[a] == -1) {
        Ans[a] = p;
        p++;
        path(G[a].first);
        path(G[a].second);
    }
    if (T[a] == 0) {
        path(G[a].first);
        Ans[a] = p;
        p++;
        path(G[a].second);
    }
    if (T[a] == 1) {
        path(G[a].first);
        path(G[a].second);
        Ans[a] = p;
        p++;
    }
}

void solve1() {
    G.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> G[i].first >> G[i].second;
        G[i].first--, G[i].second--;
    }
    T.resize(n, -1);
    ll t, l, r, x, k;
    Ans.resize(n);
    for (ll i = 0; i < q; i++) {
        cin >> t;
        if (t == 1) {
            cin >> l >> r >> x;
            for (ll j = l - 1; j <= r - 1; j++) {
                T[j] = x;
            }
        } else {
            cin >> k;
            p = 0;
            path(0);
            cout << Ans[k - 1] + 1 << " ";
        }
    }
}

void solve2() {
    D.resize(4 * n);
    build(1, 0, n);
    G.resize(n);
    T.resize(n, -1);
    for (ll i = 0; i < n; i++) {
        cin >> G[i].first >> G[i].second;
        G[i].first--, G[i].second--;
    }
    bool flag = false;
    ll t, l, r, x, k;
    Ans.resize(n);
    for (ll i = 0; i < q; i++) {
        cin >> t;
        if (t == 1) {
            cin >> l >> r >> x;
            change(1, 0, n, l - 1, r, x);
        } else {
            p=0;
            if(!flag){
                path(0);
                flag=true;
            }
            cin >> k;
            cout << Ans[k - 1] + 1 << " ";
        }
    }
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    cin >> n >> q;
    if(n<=5000 and q<=5000){
        solve1();
    }
    else{
        solve2();
    }
}