#include <bits/stdc++.h>

#define ll long long
using namespace std;
ll n, k, t;
vector<vector<ll>> G;

ll binp(ll a, ll b) {
    ll l = 0;
    ll r = n + 1;
    ll m;
    while (l + 1 != r) {
        m = (l + r) / 2;
        if (m == 0) {
            return -1;
        }
        if (a / m + b / m - (a % m == 0 and a != 0) - (b % m == 0 and b != 0) <= k) {
            r = m;
        } else {
            l = m;
        }
    }
    return l + 1;
}

void solve1() {
    if (t == 0) {
        cout << binp(0, n - 1);
    } else {
        for (ll i = 0; i < n; i++) {
            cout << binp(i, n - i - 1) << " ";
        }
    }
}

vector<ll> color;
vector<bool> used;
queue<ll> Q;

void bfs(ll a) {
    for (ll to: G[a]) {
        if (!used[to]) {
            color[to] = color[a] + 1;
            used[to] = true;
            Q.push(to);
        }
    }
    if (Q.empty()) {
        return;
    }
    ll b = Q.front();
    Q.pop();
    bfs(b);
}

vector<ll> LVL;

ll binp2() {
    ll l = 0;
    ll r = n;
    ll m;
    while (l + 1 != r) {
        m = (l + r) / 2;
        vector<ll> dp(n, 1e18);
        dp[0] = 0;
        for (ll i = 1; i < n; i++) {
            if (i <= m) {
                dp[i] = 0;
            } else {
                for (ll j = i; j > i - m; j--) {
                    dp[i] = min(dp[i], dp[j - 1] + LVL[i]);
                }
            }
        }
        if (dp[n - 1] > k) {
            l = m;
        } else {
            r = m;
        }
    }
    return l + 1;
}

void getAns(ll a) {
    color.resize(n,0);
    color.assign(n,0);
    used.resize(n,0);
    used.assign(n,0);
    used[a] = true;
    Q.push(a);
    bfs(a);
    LVL.resize(n,0);
    LVL.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        LVL[color[i]]++;
    }
    cout<< binp2()<<" ";
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    cin >> n >> k >> t;
    ll a, b;
    G.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        cin >> a >> b;
        a--, b--;
        G[a].push_back(b);
        G[b].push_back(a);
    }
    if(t==0){
        getAns(0);
    }
    else{
        for(ll i=0;i<n;i++){
            getAns(i);
        }
    }
}