#include <bits/stdc++.h>

#define ll long long
using namespace std;
ll n, k, t;
vector<vector<ll>> G;

ll binp(ll a, ll b) {
    ll l = 0;
    ll r = n + 1;
    ll m;
    while (l + 1 != r) {
        m = (l + r) / 2;
        if (m == 0) {
            return -1;
        }
        if (a / m + b / m - (a % m == 0 and a != 0) - (b % m == 0 and b != 0) <= k) {
            r = m;
        } else {
            l = m;
        }
    }
    return l + 1;
}

void solve1() {
    if (t == 0) {
        cout << binp(0, n - 1);
    } else {
        for (ll i = 0; i < n; i++) {
            cout << binp(i, n - i - 1) << " ";
        }
    }
}

vector<ll> color;
vector<bool> used;
queue<ll> Q;
vector<ll> List;

void bfs(ll a) {
    for (ll to: G[a]) {
        if (!used[to]) {
            color[to] = color[a] + 1;
            used[to] = true;
            Q.push(to);
        }
    }
    if (Q.empty()) {
        return;
    }
    ll b = Q.front();
    Q.pop();
    bfs(b);
}

vector<ll>color2;
void bfs2(ll a) {
    for (ll to: G[a]) {
        if (!used[to]) {
            color2[to] = color2[a] + 1;
            used[to] = true;
            Q.push(to);
        }
    }
    if (Q.empty()) {
        return;
    }
    ll b = Q.front();
    Q.pop();
    bfs2(b);
}

vector<ll> LVL;

void getAns(ll a) {
    color.resize(n, 0);
    used.resize(n, false);
    used[a] = true;
    Q.push(a);
    bfs(a);
    used.assign(n, false);
    ll ans = 1e18;
    for (ll i = 1; i < n; i++) {
        ll preans = 0;
        G[0].push_back(i);
        used.resize(n,false);
        color2.resize(n,0);
        bfs2(0);
        for (ll j = 0; j < n; j++) {
            preans = max(preans, color2[j]);
        }
        ans=min(ans,preans);
        G[0].resize(G[0].size()-1);
    }
    cout << ans -1 ;
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);
    cin >> n >> k >> t;
    ll a, b;
    G.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        cin >> a >> b;
        a--, b--;
        G[a].push_back(b);
        G[b].push_back(a);
    }
    if (k == 1 and t == 0) {
        getAns(0);
        return 0;
    } else {
        solve1();
    }
}